#!/usr/bin/env python
#-*- coding:utf-8 -*-

import pygtk
pygtk.require("2.0")
import gtk
import os
import sys
import uuid
import inifile8
from maindata import *
from strs import *

version = "0.0.1"

class SeeMe4(gtk.Window):
    """
        SeeMe Main Window Class
    """
    def __init__(self, sset):
        gtk.Window.__init__(self)
        self.sset = sset
        self.iniver = 0
        # GtkUIManager and GtkAccelGroup
        self.uimanager = gtk.UIManager()
        accelgroup = self.uimanager.get_accel_group()
        self.add_accel_group(accelgroup)
        # GtkActionGroup
        self.actiongroup = gtk.ActionGroup("seeme_menu")
        # GtkActionEntry
        self.ac = [ ("save", gtk.STOCK_SAVE_AS, "保存(_S)", "<Control>S", "保存", self.on_save),
                    ("reload", gtk.STOCK_REFRESH, "読み直し(_R)", None, "読み直し", self.on_reload),
                    ("textedit", None, "直接編集(_E)", "<Control>E", "直接編集", self.on_textedit),
                    ("buckup_write", None, "バックアップ作成(_S)", None, "バックアップ作成", self.on_buckup_write),
                    ("buckup_read", None, "バックアップ書き戻し(_R)", None, "バックアップ書き戻し", self.on_buckup_read),
                    ("quit", gtk.STOCK_QUIT, "終了(_Q)", "<Control>Q", "さいなら", self.on_quit),
                    ("item_new", gtk.STOCK_NEW, "新規アイテム(_N)", "<Control>N", "新規アイテム", self.on_item_new),
                    ("item_up", gtk.STOCK_GO_UP, "上に移動(_U)", "<Control>Up", "上に移動", self.on_item_up),
                    ("item_down", gtk.STOCK_GO_DOWN, "下に移動(_D)", "<Control>Down", "下に移動", self.on_item_down),
                    ("item_delete", gtk.STOCK_CLEAR, "削除(_l)", "<Control>Delete", "削除", self.on_item_delete),
                    ("apply", gtk.STOCK_OK, "リストに反映(_S)", "<Control>Return", "リストに反映(_S)", self.on_apply),
                    ("profile_edit", None, "プロファイルの編集(_E)", None, "プロファイルの編集", self.on_profile_edit),
                    ("profile_change", None, "プロファイルの切り替え(_P)", None, "プロファイルの切り替え", self.on_profile_change),
                    ("online_help", gtk.STOCK_HELP, "オンラインヘルプ(_H)", "F1", "オンラインヘルプ", self.on_online_help),
                    ("about", gtk.STOCK_ABOUT, "情報(_B)", "<Control>B", "情報", self.on_about),
                    ("file", None, "ファイル(_F)"),
                    ("buckup", None, "バックアップ(_B)"),
                    ("edit", None, "編集(_E)"),
                    ("profile", None, "プロファイル(_P)"),
                    ("help", None, "ヘルプ(_H)") ]
        self.actiongroup.add_actions(self.ac)
        self.uimanager.insert_action_group(self.actiongroup, 0)
        self.uimanager.add_ui_from_string(menu_xml)
        # GtkNoteBook
        self.note = gtk.Notebook()
        page = []
        for i in range(4):
            tab = gtk.Label(tab_label[i])
            page.append(gtk.VBox())
            #page[i].set_border_width(10)
            self.note.append_page(page[i], tab)
        # page pack
        # GtkListStore
        self.custome_liststore = gtk.ListStore(bool, str, str, str, str, bool, bool, str, int, int, int, int, str, str, int)
        self.custome_treeview = gtk.TreeView()
        self.default_liststore = gtk.ListStore(bool, str, str, str, str, bool, bool, str, int, int, int, int, str, str, int)
        self.default_treeview = gtk.TreeView()
        # on ScrolledWindow TreeView
        self.adjustment1 = gtk.Adjustment()
        self.sw1 = gtk.ScrolledWindow(self.adjustment1)
        self.sw1.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.adjustment2 = gtk.Adjustment()
        self.sw2 = gtk.ScrolledWindow(self.adjustment2)
        self.sw2.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.sw1.add(self.custome_treeview)
        self.sw2.add(self.default_treeview)
        page[0].pack_start(self.sw1)
        page[1].pack_start(self.sw2)
        self.create_treeview(self.default_treeview, self.default_liststore)
        self.create_treeview(self.custome_treeview, self.custome_liststore)
        self.read_default_searchini()
        self.read_custome_searchini()
        self.custome_treeview.get_selection().connect("changed", self.selection_changeed)
        # IniEditor
        self.editor = IniEditor()
        self.editor.button.connect("clicked", self.on_edit_accept)
        page[0].pack_start(self.editor, False)
        # main packing
        vbox = gtk.VBox()
        menubar = self.uimanager.get_widget("/MenuBar")
        toolbar = self.uimanager.get_widget("/ToolBar")
        self.statusbar = gtk.Statusbar()
        vbox.pack_start(menubar, False)
        vbox.pack_start(toolbar, False)
        vbox.pack_start(self.note)
        vbox.pack_start(self.statusbar, False)
        self.add(vbox)
        # self
        self.set_title("SeeMe for Linux")
        self.resize(self.sset.width, self.sset.height)
        self.move(self.sset.left, self.sset.top)
        self.connect("delete-event", self.on_quit)
        self.show_all()

    def close(self):
        # ドットディレクトリが存在しなければ作る
        inipath = os.environ["HOME"] + "/.seeme"
        if not os.path.exists(inipath):
            os.mkdir(inipath)
        # seeme4.ini があれば読み込んでおく
        inipath += "/seeme4.ini"
        ini = inifile8.Inifile(inipath)
        try:
            ini.write_int("Version", "File Version", 1)
            x, y = self.get_position()
            ini.write_int("Window", "Left", x)
            ini.write_int("Window", "Top", y)
            cx, cy = self.get_size()
            ini.write_int("Window", "Width", cx)
            ini.write_int("Window", "Height", cy)

            ini.write_str("Path", "Default1", self.sset.default_path)
            ini.write_str("Path", "Custome1", self.sset.custome_path)
            ini.write_str("Path", "Prefs1", self.sset.prefs_path)
            ini.write_str("Path", "Lang1", self.sset.lang_path)
            ini.write_str("Path", "Default2", self.sset.default_path2)
            ini.write_str("Path", "Custome2", self.sset.custome_path2)
            ini.write_str("Path", "Prefs2", self.sset.prefs_path2)
            ini.write_str("Path", "Lang2", self.sset.lang_path2)
            ini.write_str("Setting", "Editor", self.sset.texteditor)
            ini.write_int("Setting", "Verbtext", self.sset.verbtext)
            # 保存
            ini.save()
        except Exception, s:
            self.messagebox("%s" % s)
        gtk.main_quit()


########################################################################
#
#                          Functions
#
########################################################################


    def messagebox(self, text):
        dlg = gtk.MessageDialog(self, gtk.DIALOG_MODAL, gtk.MESSAGE_WARNING, 
                                gtk.BUTTONS_OK, text)
        dlg.set_title(messagedlg_title)  
        r = dlg.run()  
        dlg.destroy()

    def on_toggled(self, cell, path, model):
        it = model.get_iter_from_string(path)
        b = model.get_value(it, 0)
        model.set_value(it, 0, not b)

    def create_treeview(self, treeview, liststore):
        # column
        column_name = ["View", "Name", "Key", "URL"]
        for i in range(4):
            column = gtk.TreeViewColumn()
            column.set_title(column_name[i])
            treeview.append_column(column)
            # cell
            if i == 0:
                cell = gtk.CellRendererToggle()
                cell.connect("toggled", self.on_toggled, liststore)
            else:
                cell = gtk.CellRendererText()
            column.pack_start(cell)
            if i == 0:
                column.add_attribute(cell, "active", 0)
            else:
                column.add_attribute(cell, "text", i)
        # GtkListStore
        treeview.set_model(liststore)

    def read_default_searchini(self):
        self.default_liststore.clear()
        inipath = self.sset.default_path
        lngpath = self.sset.lang_path
        if os.path.exists(inipath):
            ini = inifile8.Inifile(inipath)
            lng = inifile8.InifileReader(lngpath)
            try:
                self.iniver = ini.read_int("Version", "File Version", 0)
                i = 0
                while 1:
                    i += 1
                    s = "Search Engine %i" % i
                    if not ini.section_exists(s):
                        break
                    t = ini.read_str(s, "Key", "")
                    if t == "":
                        continue
                    en = Engine();
                    en.Nameid = ini.read_int(s, "Nameid", 0);
                    if en.Nameid != 0:
                        # lng から表示名を取ってくる
                        # Google の計算方法が不明だけどコレで問題無いからイイや！
                        if en.Nameid == 17171:
                            en.Name = lng.read_str("Translation", "1632215285", "")
                        elif en.Nameid == 17183:
                            en.Name = lng.read_str("Translation", "-1971470391", "")
                        elif en.Nameid == 71103:
                            en.Name = lng.read_str("Translation", "-1453429782", "")
                        else:
                            en.Name = lng.read_str("Translation", str(en.Nameid), "")
                        if en.Name == "":
                            n = -1752227277 - en.Nameid;
                            en.Name = lng.read_str("Translation", str(n), "")
                    else:
                        en.Name = ini.read_str(s, "Name", "")
                    en.Key = t
                    en.URL = ini.read_str(s, "URL", "")
                    en.Query = ini.read_str(s, "Query", "")
                    en.Is_post = ini.read_bool(s, "Is post", False)
                    en.Has_endseparator = ini.read_bool(s, "Has endseparator", False)
                    en.Encoding = ini.read_str(s, "Encoding", "utf-8")
                    en.Search_Type = ini.read_int(s, "Search Type", 0)
                    en.Position = ini.read_int(s, "Position", -1)
                    en.Verbtext = ini.read_int(s, "Verbtext", 0)
                    en.Deleted = True #！
                    en.UNIQUEID = ini.read_str(s, "UNIQUEID", "")
                    en.ICON = ini.read_str(s, "ICON", "")
                    en.UseTLD = ini.read_int(s, "UseTLD", 0)
                    self.default_liststore.append( [en.Deleted, en.Name, en.Key, en.URL, en.Query,
                            en.Is_post, en.Has_endseparator, en.Encoding, en.Search_Type, en.Position,
                            en.Nameid, en.Verbtext, en.ICON, en.UNIQUEID, en.UseTLD] )
                        #bool, str, str, str, str,   bool, bool, str, int, int,   int, int, str, str, int
            except Exception, s:
                self.messagebox("%s" % s)
                sys.exit()

    def read_custome_searchini(self):
        self.custome_liststore.clear()
        inipath = self.sset.custome_path
        if os.path.exists(inipath):
            ini = inifile8.Inifile(inipath)
            try:
                if self.iniver == 0:
                    self.iniver = ini.read_int("Version", "File Version", 0)
                i = 0
                while 1:
                    i += 1
                    s = "Search Engine %i" % i
                    if not ini.section_exists(s):
                        break
                    t = ini.read_str(s, "Key", "")
                    if t == "":
                        continue
                    en = Engine();
                    en.Name = ini.read_str(s, "Name", "")
                    en.Key = t
                    en.URL = ini.read_str(s, "URL", "")
                    en.Query = ini.read_str(s, "Query", "")
                    en.Is_post = ini.read_bool(s, "Is post", False)
                    en.Has_endseparator = ini.read_bool(s, "Has endseparator", False)
                    en.Encoding = ini.read_str(s, "Encoding", "utf-8")
                    en.Search_Type = ini.read_int(s, "Search Type", 0)
                    en.Position = ini.read_int(s, "Position", -1)
                    en.Nameid = ini.read_int(s, "Nameid", 0)
                    en.Verbtext = ini.read_int(s, "Verbtext", 0)
                    en.Deleted = not ini.read_bool(s, "Deleted", False)
                    en.UNIQUEID = ini.read_str(s, "UNIQUEID", "")
                    en.ICON = ini.read_str(s, "ICON", "")
                    en.UseTLD = ini.read_int(s, "UseTLD", 0)
                    # Default Delete as No append
                    default_delete = False
                    if not en.Deleted:
                        for row in self.default_liststore:
                            uid = row[13]
                            if uid == en.UNIQUEID:
                                row[0] = False
                                default_delete = True
                                break
                    if not default_delete:
                        self.custome_liststore.append( [en.Deleted, en.Name, en.Key, en.URL, en.Query,
                            en.Is_post, en.Has_endseparator, en.Encoding, en.Search_Type, en.Position,
                            en.Nameid, en.Verbtext, en.ICON, en.UNIQUEID, en.UseTLD] )
            except Exception, s:
                self.messagebox("%s" % s)
                sys.exit()

    def create_uuid(self):
        uuids = []
        for row in self.default_liststore:
            uuids.append(row[13])
        for row in self.custome_liststore:
            uuids.append(row[13])
        while 1:
            result = uuid.uuid4()
            if result in uuids:
                continue
            return result


########################################################################
#
#                          Menu and Toolbar
#
########################################################################


    def on_save(self, widget, event=None):
        pass

    def on_reload(self, widget, event=None):
        pass

    def on_textedit(self, widget, event=None):
        pass

    def on_buckup_write(self, widget, event=None):
        pass

    def on_buckup_read(self, widget, event=None):
        pass

    def on_quit(self, widget, event=None):
        self.close()
        return True

    def on_item_new(self, widget, event=None):
        pass

    def on_item_up(self, widget, event=None):
        pass

    def on_item_down(self, widget, event=None):
        pass

    def on_item_delete(self, widget, event=None):
        pass

    def on_apply(self, widget, event=None):
        pass

    def on_save(self, widget, event=None):
        pass

    def on_profile_edit(self, widget, event=None):
        pass

    def on_profile_change(self, widget, event=None):
        pass

    def on_online_help(self, widget, event=None):
        pass

    def on_about(self, widget, event=None):
        url = "http://palepoli.skr.jp/"
        w = gtk.AboutDialog()
        w.set_transient_for(self)
        w.set_program_name("SeeMe for Linux")
        w.set_version(version)
        w.set_copyright("Copyright(C) 2009 sasakima-nao")
        w.set_license("GPL")
        #w.set_logo(self.icon)
        # コメントは得に入れたものがないので GTK のバージョンでも
        v = "GTK+ Version %d.%d.%d\n" % gtk.ver
        v += "PyGtk Version %d.%d.%d" % gtk.pygtk_version
        w.set_comments(v)
        # set_url_fook は website より先に書かないと認識しない
        def about_url(about, link, data): os.system("xdg-open %s" % link)
        gtk.about_dialog_set_url_hook(about_url, url)
        w.set_website(url)
        w.set_website_label(url)
        w.run()
        w.destroy()

    def on_edit_accept(self, widget, event=None):
        model, it = self.custome_treeview.get_selection().get_selected()
        self.custome_liststore.set_value(it, 1, self.editor.edit_name.get_text())
        self.custome_liststore.set_value(it, 2, self.editor.edit_key.get_text())
        self.custome_liststore.set_value(it, 3, self.editor.edit_url.get_text())
        self.custome_liststore.set_value(it, 4, self.editor.edit_query.get_text())
        self.custome_liststore.set_value(it, 5, self.editor.check_post.get_active())
        self.custome_liststore.set_value(it, 6, self.editor.check_separator.get_active())
        self.custome_liststore.set_value(it, 7, self.editor.edit_encode.get_text())
        self.custome_liststore.set_value(it, 8, int(self.editor.edit_type.get_text()))
        self.custome_liststore.set_value(it, 12, self.editor.edit_icon.get_text())
        self.custome_liststore.set_value(it, 13, self.editor.edit_uniqueid.get_text())

    def selection_changeed(self, widget, event=None):
        """
            [en.Deleted, en.Name, en.Key, en.URL, en.Query,
            en.Is_post, en.Has_endseparator, en.Encoding, en.Search_Type, en.Position,
            en.Nameid, en.Verbtext, en.ICON, en.UNIQUEID, en.UseTLD]
        """
        model, it = self.custome_treeview.get_selection().get_selected()
        self.editor.edit_name.set_text(self.custome_liststore.get_value(it, 1))
        self.editor.edit_key.set_text(self.custome_liststore.get_value(it, 2))
        self.editor.edit_url.set_text(self.custome_liststore.get_value(it, 3))
        self.editor.edit_query.set_text(self.custome_liststore.get_value(it, 4))
        self.editor.check_post.set_active(self.custome_liststore.get_value(it, 5))
        self.editor.check_separator.set_active(self.custome_liststore.get_value(it, 6))
        self.editor.edit_encode.set_text(self.custome_liststore.get_value(it, 7))
        self.editor.edit_type.set_text(str(self.custome_liststore.get_value(it, 8)))
        self.editor.edit_icon.set_text(self.custome_liststore.get_value(it, 12))
        self.editor.edit_uniqueid.set_text(self.custome_liststore.get_value(it, 13))
        self.editor.etc_label.set_text("<span color=\"darkgreen\">Verfbtext = %d  Position = %d  NameID = %d  UseTLD = %d  </span>" %
            (self.custome_liststore.get_value(it, 11), self.custome_liststore.get_value(it, 9),
            self.custome_liststore.get_value(it, 10), self.custome_liststore.get_value(it, 14)))
        self.editor.etc_label.set_use_markup(True)
        

########################################################################
#
#                               Editor
#
########################################################################


class IniEditor(gtk.Table):
    def __init__(self):
        gtk.Table.__init__(self, 6, 7)
        label = []
        for i in range(len(editor_label)):
            l = gtk.Label(editor_label[i])
            label.append(l)
        self.edit_name = gtk.Entry()
        self.attach(self.edit_name, 1, 2, 0, 1)
        self.edit_key = gtk.Entry()
        self.attach(self.edit_key, 3, 5, 0, 1, 0)
        self.edit_url = gtk.Entry()
        self.attach(self.edit_url, 1, 6, 1, 2)
        self.edit_query = gtk.Entry()
        self.attach(self.edit_query, 1, 6, 2, 3)
        self.edit_uniqueid = gtk.Entry()
        self.attach(self.edit_uniqueid, 1, 5, 3, 4)
        self.check_post = gtk.CheckButton(editor_check[0])
        self.attach(self.check_post, 5, 6, 3, 4, gtk.FILL)
        self.edit_icon = gtk.Entry()
        self.attach(self.edit_icon, 1, 5, 4, 5)
        self.check_separator = gtk.CheckButton(editor_check[1])
        self.attach(self.check_separator, 5, 6, 4, 5, gtk.FILL)
        self.edit_encode = gtk.Entry()
        self.attach(self.edit_encode, 1, 4, 5, 6)
        self.edit_type = gtk.Entry()
        self.attach(self.edit_type, 5, 6, 5, 6, 0)
        # Label
        self.attach(label[0], 0, 1, 0, 1, gtk.FILL)
        self.attach(label[1], 2, 3, 0, 1, 0, xpadding=10)
        self.attach(label[2], 0, 1, 1, 2, 0)
        self.attach(label[3], 0, 1, 2, 3, 0)
        self.attach(label[4], 0, 1, 3, 4, 0)
        self.attach(label[5], 0, 1, 4, 5, 0)
        self.attach(label[6], 0, 1, 5, 6, 0)
        self.attach(label[7], 4, 5, 5, 6, 0)
        self.etc_label = gtk.Label("<span color=\"darkgreen\">Verfbtext =  Position =  NameID =  UseTLD =  </span>")
        self.etc_label.set_use_markup(True)
        #self.etc_label.set_justify(gtk.JUSTIFY_LEFT)
        self.etc_label.set_alignment(0.1, 1.0)
        self.attach(self.etc_label, 0, 6, 6, 7)
        # Button
        self.button = gtk.Button("Reflected")
        self.attach(self.button, 5, 6, 0, 1, 0)


########################################################################
#
#                               Welcome
#
########################################################################


class WelcomeDlg():
    def __init__(self, sset):
        """
            Welcome Dialog
        """
        self.w = gtk.Dialog("SeeMe へようこそ", 
                            None,
                            gtk.DIALOG_MODAL,
                            (gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,
                            gtk.STOCK_OK, gtk.RESPONSE_ACCEPT) )
        description = gtk.Label(welcome_description)
        self.w.vbox.pack_start(description, False, False)
        sp = gtk.HSeparator()
        self.w.vbox.pack_start(sp, False)
        names = ["Default search.ini", "Custome search.ini", "operaprefs.ini", "lng File"]
        self.entrys = []
        for name in names:
            hbox = gtk.HBox()
            label = gtk.Label(name)
            label.set_size_request(150, -1)
            entry = gtk.Entry()
            hbox.pack_start(label, False, False)
            hbox.pack_start(entry)
            self.w.vbox.pack_start(hbox, False, False)
            self.entrys.append(entry)
        if sset.default_path == "":
            self.entrys[0].set_text("/usr/share/opera/locale/en/search.ini")
        else:
            self.entrys[0].set_text(sset.default_path)
        if sset.custome_path == "":
            s = os.path.expanduser("~/.opera/search.ini")
            self.entrys[1].set_text(s)
        else:
            self.entrys[1].set_text(sset.custome_path)
        if sset.prefs_path == "":
            s = os.path.expanduser("~/.opera/operaprefs.ini")
            self.entrys[2].set_text(s)
        else:
            self.entrys[2].set_text(sset.prefs_path)
        if sset.lang_path == "":
            self.entrys[3].set_text("/usr/share/opera/locale/en/en.lng")
        else:
            self.entrys[3].set_text(sset.lang_path)
        self.w.set_size_request(500, -1)
        self.w.show_all()

########################################################################
#
#                               main
#
########################################################################


def messagebox(text):
    dlg = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_WARNING, 
                            gtk.BUTTONS_OK, text)
    dlg.set_title(messagedlg_title)  
    r = dlg.run()  
    dlg.destroy()

def main():
    inipath = os.path.expanduser("~/.seeme/seeme4.ini")
    sset = SeeMeSetting()
    #if os.path.exists(inipath):
    ini = inifile8.Inifile(inipath)
    try:
        sset.version = ini.read_int("Version", "File Version", 0)
        sset.width = ini.read_int("Window", "Width", 500)
        sset.height = ini.read_int("Window", "Height", 500)
        sset.top = ini.read_int("Window", "Top", 100)
        sset.left = ini.read_int("Window", "Left", 100)
        sset.default_path = ini.read_str("Path", "Default1", "")
        sset.custome_path = ini.read_str("Path", "Custome1", "")
        sset.prefs_path = ini.read_str("Path", "Prefs1", "")
        sset.lang_path = ini.read_str("Path", "Lang1", "")
        sset.default_path2 = ini.read_str("Path", "Default2", "")
        sset.custome_path2 = ini.read_str("Path", "Custome2", "")
        sset.prefs_path2 = ini.read_str("Path", "Prefs2", "")
        sset.lang_path2 = ini.read_str("Path", "Lang2", "")
        sset.texteditor = ini.read_str("Setting", "Editor", "")
        sset.verbtext = ini.read_int("Setting", "Verbtext", 0)
    except Exception, s:
        messagebox("%s" % s)
        sys.exit()
    if sset.version < 1:
        dlg = WelcomeDlg(sset)
        try:
            if dlg.w.run() == gtk.RESPONSE_ACCEPT:
                sset.default_path = dlg.entrys[0].get_text()
                sset.custome_path = dlg.entrys[1].get_text()
                sset.prefs_path =   dlg.entrys[2].get_text()
                sset.lang_path =    dlg.entrys[3].get_text()
            else:
                messagebox("bye !")
                sys.exit()
        except Exception, s:
            messagebox("%s" % s)
        finally:
            dlg.w.destroy()
    SeeMe4(sset)
    gtk.main()

if __name__ == "__main__":
    main()
